



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python3 第十七章 - sequence（序列）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python3 第十七章 - sequence（序列）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 19:41:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>之前我们在讲for循环语句时就提到过序列，那么什么是序列(sequence)？</p>
<p>序列是Python中最基本的数据结构。序列中的每个元素都分配一个数字 &mdash;&mdash; 它的索引（位置），第一个索引是0，第二个索引是1，依此类推。</p>
<ul><li>Python有6个序列的内置类型：列表、元组、字符串、Unicode字符串、buffer对象、range对象（在python3中取消了range，同时将xrange重新命名成range）。</li>
<li>序列都可以进行的操作：索引、切片（分片）、序列相加、乘法、成员资格（检查成员）、长度、最小值和最大值</li></ul>
<p><strong>1. 索引</strong></p>
<p>序列中所有的元素都是有编号的--从0开始递增。可以通过编号分别对序列的元素进行访问。Python的序列也可以从右边开始索引，最右边的一个元素的索引为-1，向左开始递减。</p>
<p>实例：</p>
<div>
<pre class="prettyprint linenums">greeting = 'Hello'<br />
print('greeting[2]', greeting[2])<br />
print('greeting[-1]', greeting[-1])

language = ['c', 'c++', 'python', 'c#']<br />
print('language[2]', language[2])</pre>
</div>
<p>以上代码，输出：</p>
<div>
<pre class="prettyprint linenums">greeting[2] l<br />
greeting[-1] o<br />
language[2] python</pre>
</div>
<p><strong>2、切片</strong><br />索引用来对单个元素进行访问，用切片可以对一定范围内的元素进行访问，切片通过冒号相隔的两个索引来实现。切片操作的实现需要提供两个索引作为边界，第一个索引的元素是包含在切片内的，第二个则不包含在切片内。</p>
<p>实例：</p>
<div>
<pre class="prettyprint linenums">number = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]

# 取索引为第二和第三的元素<br />
print('number[2:4]：', number[2:4])

# 负数表明是从右开始计数<br />
print('number[-4:-1]：', number[-4:-1])

# 把第二个索引置空，表明包括到序列结尾的元素<br />
print('number[-4:]：', number[-4:])

# 同上，把第一个索引置空，表明包含序列开始的元素<br />
print('number[:3]：', number[:3])

# 默认在分片的时候，步长为1,这样指定步长为1，和默认的效果一样<br />
print('number[0:10:1]：', number[0:10:1])

# 这里指定步长为2，这样就会跳过某些序列元素<br />
print('number[0:10:2]：', number[0:10:2])

# 步长也可以是负数，但是第一个索引一定要大于第二个索引<br />
print('number[10:0:-1]：', number[10:0:-1])<br />
print('number[10:0:-2]：', number[10:0:-2])</pre>
</div>
<p>以上代码，输出：</p>
<div>
<pre class="prettyprint linenums">number[2:4]： [3, 4]<br />
number[-4:-1]： [7, 8, 9]<br />
number[-4:]： [7, 8, 9, 10]<br />
number[:3]： [1, 2, 3]<br />
number[0:10:1]： [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]<br />
number[0:10:2]： [1, 3, 5, 7, 9]<br />
number[10:0:-1]： [10, 9, 8, 7, 6, 5, 4, 3, 2]<br />
number[10:0:-2]： [10, 8, 6, 4, 2]</pre>
</div>
<p>对于一个正数步长，Python会从序列的头部开始向右提取元素，直到最后一个元素，而对于负数步长，则是从序列的尾部开始向左提取元素，直到第一个元素</p>
<p><strong>3、序列相加</strong></p>
<div>
<pre class="prettyprint linenums">number = [1, 2, 3, 4, 5]<br />
number2 = [6, 7, 8, 9, 10]

greeting = ['hello', 'world']<br />
greeting2 = ['python']

print('number + number2：', number + number2)<br />
print('greeting + greeting2：', greeting + greeting2)<br />
print('number + greeting：', number + greeting)</pre>
</div>
<p>以上代码，输出：</p>
<div>
<pre class="prettyprint linenums">number + number2： [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]<br />
greeting + greeting2： ['hello', 'world', 'python']<br />
number + greeting： [1, 2, 3, 4, 5, 'hello', 'world']</pre>
</div>
<p>从第三行的输出中我们可以看出，在python3.6中，不同数据类型的序列也是可以相加的，但你不要这么去使用，因为后面你用min和max找最小值和最大值时会报错。</p>
<p><strong>4、乘法</strong></p>
<p>用数字n剩以一个序列会生成新的序列，而在新的序列中，原来的序列将会被重复n次。</p>
<div>
<pre class="prettyprint linenums">number = [1, 2, 3, 4, 5]<br />
greeting = ['hello', 'world']

print('number * 2：', number * 2)<br />
print('greeting * 3', greeting * 3)</pre>
</div>
<p>以上代码，输出：</p>
<div>
<pre class="prettyprint linenums">number * 2： [1, 2, 3, 4, 5, 1, 2, 3, 4, 5]<br />
greeting * 3 ['hello', 'world', 'hello', 'world', 'hello', 'world']</pre>
</div>
<p><strong>5、成员资格</strong></p>
<p>可以使用in运算符来检查一个值是否在序列中，如果在其中，就返回Ture，如果不在，就返回False。</p>
<div>
<pre class="prettyprint linenums">greeting = ['hello', 'world']

if 'hello' in greeting:<br />
    print('\'hello\' 在 greeting 中')<br />
else:<br />
    print('\'hello\' 不在 greeting 中')

if 'python' in greeting:<br />
    print('\'python\' 在 greeting 中')<br />
else:<br />
    print('\'python\' 不在 greeting 中')</pre>
</div>
<p>以上代码，输出：</p>
<div>
<pre class="prettyprint linenums">'hello' 在 greeting 中<br />
'python' 不在 greeting 中</pre>
</div>
<p><strong>6、长度、最小值和最大值</strong></p>
<p>内建函数len、min和max分别返回序列所包含的元素的数量，序列中的最小元素和序列中的最大元素。</p>
<div>
<pre class="prettyprint linenums">number = [1, 2, 3, 4, 5]<br />
greeting = ['hello', 'world']

print('max(number)：', max(number))<br />
print('min(number)：', min(number))<br />
print('len(number)：', len(number))

print('max(greeting)：', max(greeting))<br />
print('min(greeting)：', min(greeting))<br />
print('len(greeting)：', len(greeting))</pre>
</div>
<p>以上代码，输出：</p>
<div>
<pre class="prettyprint linenums">max(number)： 5<br />
min(number)： 1<br />
len(number)： 5<br />
max(greeting)： world<br />
min(greeting)： hello<br />
len(greeting)： 2</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqly7x9o.html">CentOS系统配置 iptables防火墙</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901ed38.html">SQL Server调优系列进阶篇（查询语句运行几个指标值监测）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7rwe18.html">Unity 由Verlet数值积分产生的头发运动</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v70do8.html">【转】MYSQL入门学习之四：MYSQL的数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnk7zoq.html">PostgreSQL的 initdb 源代码分析之二十四</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyx0z8.html">cocos2d源码剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1l1gz9.html">event&period;preventDefault和恢复元素默认事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mk6djq.html">boost库在工作（39）网络UDP异步服务端之九</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2woe53q.html">JavaScript类的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnpv7z8.html">整理：GET与POST的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zel549.html">BZOJ 3648&colon; 寝室管理&lpar; 点分治 &plus; 树状数组 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vo6dn8.html">已经包含了&num;include &amp;lt&semi;atlcom&period;h&amp;gt&semi;  &num;include &amp;lt&semi;comutil&period;h&amp;gt&semi;还是报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnomm6q.html">【Chromium中文文档】Web安全研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1w1wdq.html">道路软件质量：SourceMonitor</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mejzo2q.html">inception cenOS 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zojevvq.html">burpsuite&plus;sqlmap跨登录验证SQL注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pzzn38.html">记录下 Markdown 语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zjv4x9.html">linux下配置Tomcat开机启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojw4y1q.html">STAThread 和 MTAThread</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y1okn8.html">&lbrack;HNOI2009&rsqb;有趣的数列</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy1ozjgq.html">Atlas 安装报错 package Atlas-2&period;2&period;1-1&period;x86&lowbar;64 is intended for a x86&lowbar;64 architecture</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z6rln9.html">adb 获取Android手机信息命令&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdvzm79.html">Latex 学习之旅（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zj4ge9.html">Shell和命令基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1n5voq.html">HTML5&mdash;&mdash;localStorage</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z3xok9.html">初学Vue之数量加减</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey21om9.html">viewport预备知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjxdek8.html">MySQL中MyISAM 和 InnoDB 的基本区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey2y7j9.html">从头开始基于Maven搭建SpringMVC&plus;Mybatis项目&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoxoz3q.html">把玩爬虫框架Gecco</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
